% Forma baricéntrica de la interpolación

% Para nodos equiespaciados, se puede tomar
% w_j = (-1)^j * binom(n,j)

% Interpolemos y=sen(x) en [-pi,pi] con n+1
% nodos equiespaciados.
a = -pi;
b = pi;
n = 10;
x = linspace(a,b,n+1);
y = sin(x);

% Cálculo de w_j
w = zeros(n+1,1);
for j =0:n
    w(j+1) = (-1)^j*nchoosek(n,j);
end

figure(1)
plot(x,y,'bo')
hold on
t = linspace(a,b,300);
plot(t,sin(t),'r--', t,lagr_bar(x,y,w,t),'g')
hold off
figure(2)
plot(t,sin(t)-lagr_bar(x,y,w,t))
